package com.tds.tapad.demo;

import static android.view.View.GONE;

import android.Manifest;
import android.app.AppOpsManager;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.PixelFormat;
import android.os.Binder;
import android.os.Build;
import android.os.Bundle;
import android.provider.Settings;
import android.support.annotation.IdRes;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.view.Gravity;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

import com.tapsdk.tapad.BuildConfig;
import com.tapsdk.tapad.Callback;
import com.tapsdk.tapad.CustomUser;
import com.tapsdk.tapad.TapAdConfig;
import com.tapsdk.tapad.TapAdCustomController;
import com.tapsdk.tapad.TapAdLocation;
import com.tapsdk.tapad.TapAdManager;
import com.tapsdk.tapad.TapAdSdk;
import com.tapsdk.tapad.UserAction;
import com.tapsdk.tapad.exceptions.AdException;
import com.tapsdk.tapad.internal.utils.TapADLogger;
import com.tds.tapad.demo.R;
import com.tds.tapad.demo.banner.BannerHostActivity;
import com.tds.tapad.demo.feed.ExpressFeedViewActivity;
import com.tds.tapad.demo.feed.FeedRecyclerViewActivity;
import com.tds.tapad.demo.interstitial.InterstitialActivity;
import com.tds.tapad.demo.reward.RewardHostActivity;
import com.tds.tapad.demo.splash.SplashHostActivity;
import com.tds.tapad.demo.utils.ViewUtils;
import com.tds.tapad.demo.views.BaseActivity;

import org.json.JSONArray;
import org.json.JSONObject;

import java.lang.reflect.Field;
import java.lang.reflect.Method;

public class MainActivity extends BaseActivity implements SimpleViewBinding {

    private boolean enableCustomRecommend = true;

    private boolean isInit = false;

    private static final WindowManager.LayoutParams LAYOUT_PARAMS;

    private boolean enableGetIMEI = false;

    private boolean enableGetAndroidId = false;

    private boolean enableGetLocation = false;

    private boolean enableGetAppList = true;


    private void initGetPersonalInfo() {
        enableGetIMEI = false;
        enableGetAndroidId = false;
        enableGetLocation = false;
        enableGetAppList = false;
        updateView(R.id.enableGetIMEIButton, false);
        updateView(R.id.enableGetAndroidIdButton, false);
        updateView(R.id.enableGetLocationButton, false);
        updateView(R.id.enableGetAListButton, false);
    }

    private void initToggleSwitchView() {
        findViewById(R.id.enableGetIMEIButton).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                toggleSwitch(view.getId());
            }
        });

        findViewById(R.id.enableGetAndroidIdButton).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                toggleSwitch(view.getId());
            }
        });

        findViewById(R.id.enableGetLocationButton).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                toggleSwitch(view.getId());
            }
        });

        findViewById(R.id.enableGetAListButton).setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {
                toggleSwitch(view.getId());
            }
        });
    }

    private boolean initFormal() {

        findViewById(R.id.initButton).setVisibility(GONE);
        findViewById(R.id.getIMEIRelativeLayout).setVisibility(GONE);
        findViewById(R.id.getAndroidIdRelativeLayout).setVisibility(GONE);
        findViewById(R.id.getLocationRelativeLayout).setVisibility(GONE);
        findViewById(R.id.getAppListRelativeLayout).setVisibility(GONE);

        final TapAdConfig config = new TapAdConfig.Builder()
                .withMediaId(1008781)
                .withMediaName("联盟正式-Android-外部测试用")
                .withMediaKey("ejnr0qv6G0X8w8hLn0ybw9FamecAwMYmjE9P26FhStPTPIEW73HxReUzE9HLjwQu")
                .withMediaVersion("1")
                .withGameChannel("taptap")
                .withTapClientId("0RiAlMny7jiz086FaU")
                .enableDebug(true)
                .withCustomController(new TapAdCustomController() {
                    @Override
                    public boolean isCanUseLocation() {
                        return enableGetLocation;
                    }

                    @Override
                    public TapAdLocation getTapAdLocation() {
                        double longitude = 0;
                        double latitude = 0;
                        double accuracy = 0;
                        return new TapAdLocation(longitude, latitude, accuracy);
                    }

                    @Override
                    public boolean isCanUsePhoneState() {
                        return enableGetIMEI;
                    }

                    @Override
                    public String getDevImei() {
                        return super.getDevImei();
                    }

                    @Override
                    public boolean isCanUseWifiState() {
                        return super.isCanUseWifiState();
                    }

                    @Override
                    public boolean isCanUseWriteExternal() {
                        return super.isCanUseWriteExternal();
                    }

                    @Override
                    public String getDevOaid() {
                        return "";
                    }

                    @Override
                    public boolean alist() {
                        return enableGetAppList;
                    }

                    @Override
                    public boolean isCanUseAndroidId() {
                        return enableGetAndroidId;
                    }

                    @Override
                    public CustomUser provideCustomUser() {
                        int avatarLevel = -1;
                        return new CustomUser.Builder()
                                .withRealAge(1)                   // 年龄
                                .withRealSex(1)                   // 性别 0:男 1：女
                                .withAvatarSex(1)           // 角色性别 0:男 1：女
                                .withAvatarLevel(avatarLevel)            // 角色等级
                                .withNewUserStatus(1)          // 是否新玩家 0:否；1:是
                                .withPayedUserStatus(1)        // 是否付费用户 0:否；1:是
                                .withBeginMissionFinished(1) // 是否通过新手教程 0:否 1:是
                                .withAvatarPayedToolCnt(1)        // 角色当前付费道具数量
                                .build();
                    }
                })
                .build();

        TapAdSdk.init(this, config);
        return false;
    }

    private void updateCustomRecommend(boolean enabled) {
        if (enabled) {
            ((Button) findViewById(R.id.customRecommendButton)).setText("关闭个性化推荐");
        } else {
            ((Button) findViewById(R.id.customRecommendButton)).setText("打开个性化推荐");
        }
        TapAdConfig tapAdConfig = new TapAdConfig.Builder().withData(getData(enabled)).build();
        TapAdSdk.updateAdConfig(tapAdConfig);
    }

    private String getData(boolean enabled) {
        if (enabled) return "";
        try {
            JSONArray jsonArray = new JSONArray();
            JSONObject personalObject = new JSONObject();
            personalObject.put("name", "personal_ads_type");
            personalObject.put("value", "0");
            jsonArray.put(personalObject);
            return jsonArray.toString();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "";
    }

    private boolean isTestServer = false;

    private String removeHotTag(String source) {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < source.length(); i++) {
            char ch = source.charAt(i);
            if (ch == 'h' || ch == '_') {
                break;
            } else {
                sb.append(ch);
            }
        }

        return sb.toString();
    }

    private void updateView(@IdRes int id, boolean enabled) {
        ((Button) findViewById(id)).setText(enabled ? "打开" : "关闭");
    }

    private void toggleSwitch(@IdRes int id) {
        if (id == R.id.enableGetIMEIButton) {
            enableGetIMEI = !enableGetIMEI;
            updateView(id, enableGetIMEI);
        } else if (id == R.id.enableGetAndroidIdButton) {
            enableGetAndroidId = !enableGetAndroidId;
            updateView(id, enableGetAndroidId);
        } else if (id == R.id.enableGetLocationButton) {
            enableGetLocation = !enableGetLocation;
            updateView(id, enableGetLocation);
        } else if (id == R.id.enableGetAListButton) {
            enableGetAppList = !enableGetAppList;
            updateView(id, enableGetAppList);
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
        setContentView(R.layout.activity_main);
        initGetPersonalInfo();
        initToggleSwitchView();
        setCustomActionBarTitleTextResource(R.string.app_name);
        hideBackButton();
        bindViews();
        updateCustomRecommend(enableCustomRecommend);

        bindButton(R.id.enterShowRewardButton, RewardHostActivity.class);
        bindButton(R.id.enterShowBannerButton, BannerHostActivity.class);
        bindButton(R.id.enterShowSplashButton, SplashHostActivity.class);
        bindButton(R.id.enterFeedRecyclerViewButton, FeedRecyclerViewActivity.class);
        bindButton(R.id.enterTemplateFeedAdButton, ExpressFeedViewActivity.class);
        bindButton(R.id.enterInterstitialButton, InterstitialActivity.class);
        findViewById(R.id.customRecommendButton).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                enableCustomRecommend = !enableCustomRecommend;
                updateCustomRecommend(enableCustomRecommend);
            }
        });

        TextView versionTextView = (TextView) findViewById(R.id.versionTextView);
        versionTextView.setText("版本：" + removeHotTag(BuildConfig.SDK_VERSION_NAME));

        findViewById(R.id.requestAdPermissions).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                TapAdManager.get().requestPermissionIfNecessary(MainActivity.this);
            }
        });

        findViewById(R.id.testUserActionButton).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                UserAction[] userActions = new UserAction[3];

                for (int i = 0; i < 3; i++) {
                    UserAction tmp = new UserAction.Builder()
                            .withActionType(i)
                            .withActionTime(System.currentTimeMillis())
                            .withAmount(i * 1000)
                            .withWinStatus(i % 2)
                            .build();
                    userActions[i] = tmp;
                }
                TapAdManager.get().uploadUserAction(userActions, new Callback() {
                    @Override
                    public void onSuccess() {
                        Toast.makeText(MainActivity.this, "上报成功", Toast.LENGTH_SHORT).show();
                    }

                    @Override
                    public void onError(AdException exception) {
                        Toast.makeText(MainActivity.this, "上报出错:" + exception.getMessage(), Toast.LENGTH_SHORT).show();
                    }
                });
            }
        });


        ((ToggleButton) findViewById(R.id.enableGetAndroidLocationToggleButton)).setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean checked) {
                enableGetAndroidId = checked;
            }
        });
    }

    private void bindButton(@IdRes int id, final Class<?> clz) {
        findViewById(id).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(MainActivity.this, clz);
                startActivity(intent);
            }
        });
    }

    private static boolean checkFloatPermission(Context context) {
        if (Build.VERSION.SDK_INT < Build.VERSION_CODES.M) {
            try {
                Class cls = Class.forName("android.content.Context");
                Field declaredField = cls.getDeclaredField("APP_OPS_SERVICE");
                declaredField.setAccessible(true);
                Object obj = declaredField.get(cls);
                if (!(obj instanceof String)) {
                    return false;
                }
                String str2 = (String) obj;
                obj = cls.getMethod("getSystemService", String.class).invoke(context, str2);
                cls = Class.forName("android.app.AppOpsManager");
                Field declaredField2 = cls.getDeclaredField("MODE_ALLOWED");
                declaredField2.setAccessible(true);
                Method checkOp = cls.getMethod("checkOp", Integer.TYPE, Integer.TYPE, String.class);
                int result = (Integer) checkOp.invoke(obj, 24, Binder.getCallingUid(), context.getPackageName());
                return result == declaredField2.getInt(cls);
            } catch (Exception e) {
                return false;
            }
        } else {
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
                AppOpsManager appOpsMgr = (AppOpsManager) context.getSystemService(Context.APP_OPS_SERVICE);
                if (appOpsMgr == null)
                    return false;
                int mode = appOpsMgr.checkOpNoThrow("android:system_alert_window", android.os.Process.myUid(), context
                        .getPackageName());
                return mode == AppOpsManager.MODE_ALLOWED || mode == AppOpsManager.MODE_IGNORED;
            } else {
                return Settings.canDrawOverlays(context);
            }
        }
    }


    static {
        WindowManager.LayoutParams params = new WindowManager.LayoutParams();
        params.x = 0;
        params.y = 0;
        params.width = WindowManager.LayoutParams.WRAP_CONTENT;
        params.height = WindowManager.LayoutParams.WRAP_CONTENT;
        params.gravity = Gravity.CENTER | Gravity.TOP;
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            params.type = WindowManager.LayoutParams.TYPE_APPLICATION_OVERLAY;
        } else {
            params.type = WindowManager.LayoutParams.TYPE_PHONE;
        }
        params.format = PixelFormat.RGBA_8888;
        params.flags = WindowManager.LayoutParams.FLAG_NOT_TOUCH_MODAL | WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE;
        LAYOUT_PARAMS = params;
    }

    @Override
    public void onRequestPermissionsResult(int requestCode,
                                           String permissions[], int[] grantResults) {
        switch (requestCode) {
            case 1: {
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                } else {
                    Toast.makeText(MainActivity.this, "Please give me storage permission!", Toast.LENGTH_LONG).show();
                }
            }
        }
    }

    @Override
    public void bindViews() {

        ViewUtils.bindView(this, R.id.initButton, new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (isInit) {
                    return;
                }
                isInit = true;
                MainActivity.this.runOnUiThread(MainActivity.this::initFormal);
                findViewById(R.id.initButton_umeng).setVisibility(GONE);
                findViewById(R.id.initButton_crasheye).setVisibility(GONE);
                Toast.makeText(MainActivity.this, "初始化成功", Toast.LENGTH_SHORT).show();
            }
        });

        ViewUtils.bindView(this, R.id.initButton_umeng, new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (isInit) {
                    return;
                }
                isInit = true;
                MainActivity.this.runOnUiThread(MainActivity.this::initFormal);
                //initFormal();
                findViewById(R.id.initButton).setVisibility(GONE);
                findViewById(R.id.initButton_crasheye).setVisibility(GONE);
                Toast.makeText(MainActivity.this, "初始化成功", Toast.LENGTH_SHORT).show();
            }
        });

        ViewUtils.bindView(this, R.id.initButton_crasheye, new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (isInit) {
                    return;
                }
                isInit = true;
                MainActivity.this.runOnUiThread(MainActivity.this::initFormal);
                //initFormal();
                findViewById(R.id.initButton_umeng).setVisibility(GONE);
                findViewById(R.id.initButton).setVisibility(GONE);
                Toast.makeText(MainActivity.this, "初始化成功", Toast.LENGTH_SHORT).show();
            }
        });
    }
}