package com.tds.tapad.demo.feed;

import android.os.Bundle;
import android.support.annotation.Nullable;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.Toast;

import com.tapsdk.tapad.AdRequest;
import com.tapsdk.tapad.TapAdManager;
import com.tapsdk.tapad.TapAdNative;
import com.tapsdk.tapad.TapFeedAd;
import com.tapsdk.tapad.feed.FeedOption;
import com.tapsdk.tapad.feed.TapFeedAdView;
import com.tapsdk.tapad.feed.VideoOption;
import com.tds.tapad.demo.R;
import com.tds.tapad.demo.views.BaseActivity;

import java.util.List;

public class ExpressFeedViewActivity extends BaseActivity {
    private TapAdNative tapAdNative;

    private TapFeedAd tapFeedAd;

    FeedOption feedOption = new FeedOption.Builder()
            .expressWidth(ViewGroup.LayoutParams.MATCH_PARENT)
            .expressHeight(ViewGroup.LayoutParams.WRAP_CONTENT)
            .videoOption(new VideoOption.Builder().autoPlayPolicy(VideoOption.AutoPlayPolicy.ALWAYS).build())
            .build();

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_express_feed);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
        setCustomActionBarTitleTextResource(R.string.main_menu_template_feed);
        tapAdNative = TapAdManager.get().createAdNative(this);
        findViewById(R.id.fetchAdButton).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                tapAdNative.loadFeedAd(new AdRequest.Builder().withSpaceId(1039155).build(), new TapAdNative.FeedAdListener() {
                    @Override
                    public void onFeedAdLoad(List<TapFeedAd> tapFeedAds) {
                        if (tapFeedAds == null || tapFeedAds.size() == 0) return;
                        tapFeedAd = tapFeedAds.get(0);
                        tapFeedAd.setExpressRenderListener(new TapFeedAd.ExpressRenderListener() {
                            @Override
                            public void onRenderSuccess(TapFeedAdView adView) {
                                ViewGroup container = findViewById(R.id.container);
                                container.removeAllViews();
                                container.addView(adView);
                            }

                            @Override
                            public void onRenderFail(TapFeedAdView adView, TapFeedAd feedAd, int errorCode, String msg) {
                            }

                            @Override
                            public void onAdShow(TapFeedAdView adView) {

                            }

                            @Override
                            public void onAdClicked(TapFeedAdView view) {

                            }

                            @Override
                            public void onAdClosed(TapFeedAdView view) {

                            }
                        });
                        tapFeedAd.render(ExpressFeedViewActivity.this, feedOption);
                    }

                    @Override
                    public void onError(int code, String message) {
                        Toast.makeText(ExpressFeedViewActivity.this, "code:" + code + ",message:" + message, Toast.LENGTH_SHORT).show();
                    }
                });
            }
        });
    }
}
