package com.tds.tapad.demo.feed;

import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.design.widget.TabLayout;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;
import android.support.v4.view.ViewPager;
import android.view.WindowManager;
import com.tds.tapad.demo.R;
import com.tds.tapad.demo.views.BaseActivity;

public class FeedRecyclerViewActivity extends BaseActivity {

    PagerAdapter pagerAdapter;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
        setContentView(R.layout.activity_feed);
        setCustomActionBarTitleTextResource(R.string.main_menu_feed);
        new TapAdNativeSingle(this);
        initViews();
    }

    private void initViews() {
        TabLayout categoryTabLayout = findViewById(R.id.categoryTabLayout);
        categoryTabLayout.addTab(categoryTabLayout.newTab().setText("视频"));
        categoryTabLayout.addTab(categoryTabLayout.newTab().setText("大图"));

        final ViewPager feedViewPager = findViewById(R.id.feedViewPager);
        pagerAdapter = new PagerAdapter(getSupportFragmentManager(), categoryTabLayout.getTabCount());
        feedViewPager.setAdapter(pagerAdapter);
        feedViewPager.addOnPageChangeListener(new TabLayout.TabLayoutOnPageChangeListener(categoryTabLayout));

        categoryTabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                feedViewPager.setCurrentItem(tab.getPosition());
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {

            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();

    }

    @Override
    protected void onStop() {
        super.onStop();
//        if (pagerAdapter != null) pagerAdapter.stop();
    }

    @Override
    protected void onPause() {
        super.onPause();
    }

    static class PagerAdapter extends FragmentPagerAdapter {

        private int num;

        public PagerAdapter(FragmentManager fm, int num) {
            super(fm);
            this.num = num;
        }


        @Override
        public Fragment getItem(int i) {
            return createItem(i);
        }

        private Fragment createItem(int i) {
            if (1 == i) {
                return new NormalFeedAdFragment();
            } else {
                return new VideoFeedAdFragment();
            }
        }

        @Override
        public int getCount() {
            return num;
        }
    }
}
