package com.tds.tapad.demo.splash;

import android.app.Activity;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.tapsdk.tapad.TapSplashAd;
import com.tds.tapad.demo.R;


public class PortraitSplashActivity extends Activity {

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
        setContentView(R.layout.activity_splash_portrait);
        SplashAdManager.getInstance().getCachedPortraitSplashAd().setSplashInteractionListener(new TapSplashAd.AdInteractionListener() {
            @Override
            public void onAdSkip() {
                SplashAdManager.getInstance().getCachedPortraitSplashAd().dispose();
//                SplashAdManager.getInstance().getCachedLandscapeSplashAd().destroyView();
                Toast.makeText(PortraitSplashActivity.this, "点击了跳过", Toast.LENGTH_SHORT).show();
                PortraitSplashActivity.this.finish();
            }

            @Override
            public void onAdTimeOver() {
                SplashAdManager.getInstance().getCachedPortraitSplashAd().dispose();
//                SplashAdManager.getInstance().getCachedLandscapeSplashAd().destroyView();
                Toast.makeText(PortraitSplashActivity.this, "开屏光告时间已到", Toast.LENGTH_SHORT).show();
                PortraitSplashActivity.this.finish();
            }

            @Override
            public void onAdClick() {

            }
        });

//        SplashAdManager.getInstance().getCachedPortraitSplashAd().show(this);
        View splashView = SplashAdManager.getInstance().getCachedPortraitSplashAd().getSplashView(this);
        RelativeLayout relativeLayout = ((RelativeLayout)findViewById(R.id.portraitSplashRootView));
        relativeLayout.addView(splashView, new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT
                , ViewGroup.LayoutParams.WRAP_CONTENT));
        TextView localView = new TextView(this);
        localView.setText("测试");
        localView.setGravity(Gravity.CENTER);
        localView.setBackgroundColor(getResources().getColor(R.color.purple_200));
        splashView.setId(splashView.hashCode());
        RelativeLayout.LayoutParams lp = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.MATCH_PARENT, RelativeLayout.LayoutParams.MATCH_PARENT);
        lp.addRule(RelativeLayout.BELOW, splashView.getId());
        relativeLayout.addView(localView, lp);

    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        SplashAdManager.getInstance().getCachedPortraitSplashAd().dispose();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        SplashAdManager.getInstance().getCachedPortraitSplashAd().dispose();
        SplashAdManager.getInstance().cachePortraitSplashAd(null);
    }
}
