package com.tds.tapad.demo.views;

import android.app.Activity;
import android.content.Intent;
import android.support.annotation.IdRes;
import android.support.annotation.StringRes;
import android.support.v7.app.ActionBar;
import android.support.v7.app.AppCompatActivity;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.FrameLayout;
import android.widget.LinearLayout;

import com.tds.tapad.demo.R;

public class BaseActivity extends AppCompatActivity {

    CustomActionBar customActionBar;

    @Override
    public void setContentView(int resId) {
        LayoutInflater layoutInflater = getLayoutInflater();
        LinearLayout linearLayout = (LinearLayout) layoutInflater.inflate(R.layout.activity_base, null);
        customActionBar = linearLayout.findViewById(R.id.customActionBar);
        FrameLayout activityContainerFrameLayout = linearLayout.findViewById(R.id.layoutContainerFrameLayout);
        layoutInflater.inflate(resId, activityContainerFrameLayout);
        super.setContentView(linearLayout);

        try {
            ActionBar actionBar = getSupportActionBar();
            if (actionBar != null) {
                actionBar.hide();
            }
        } catch (Throwable ignore) {
        }

        customActionBar.bindViews(this);
    }

    protected void setCustomActionBarTitleTextResource(@StringRes int resourceId) {
        if (customActionBar != null) customActionBar.setTitle(getString(resourceId));
    }

    protected void hideBackButton() {
        if (customActionBar != null) customActionBar.hideBackButton();
    }

    protected void showBackButton() {
        if (customActionBar != null) customActionBar.showBackButton();
    }
}
