package com.tds.tapad.demo.views;

import android.app.Activity;
import android.content.Context;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.RelativeLayout;
import android.widget.TextView;
import com.tds.tapad.demo.R;

public class CustomActionBar extends RelativeLayout {

    private boolean bound = false;

    public CustomActionBar(Context context) {
        super(context);
        init(context);
    }

    public CustomActionBar(Context context, AttributeSet attrs) {
        super(context, attrs);
        init(context);
    }

    public CustomActionBar(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        init(context);
    }

    public CustomActionBar(Context context, AttributeSet attrs, int defStyleAttr, int defStyleRes) {
        super(context, attrs, defStyleAttr, defStyleRes);
        init(context);
    }

    private void init(Context context) {
        LayoutInflater.from(context).inflate(R.layout.view_custom_actionbar, this, true);
    }

    public void bindViews(Activity activity) {
        if (activity == null || activity.isDestroyed() || bound) {
            return;
        }

        bound = true;
        findViewById(R.id.backButton).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {
                activity.finish();
            }
        });
    }

    public void setTitle(String title) {
        ((TextView)findViewById(R.id.titleTextView)).setText(title);
    }

    public void hideBackButton() {
        findViewById(R.id.backButton).setVisibility(View.GONE);
    }

    public void showBackButton() {
        findViewById(R.id.backButton).setVisibility(View.VISIBLE);
    }
}
